Index: main/plugin-forms/pages/administrator/orphan-forms/view.xsl
===================================================================
--- main/plugin-forms/pages/administrator/orphan-forms/view.xsl	(revision 40266)
+++ main/plugin-forms/pages/administrator/orphan-forms/view.xsl	(working copy)
@@ -48,7 +48,11 @@
                        org.ametys.forms.administration.OrphanForms.addElement (
                            <xsl:value-of select="position()"/>,
                            "<xsl:value-of select="@name"/>",
-                           "<xsl:value-of select="@total"/>"
+                           "<xsl:value-of select="@total"/>",
+                           "<xsl:value-of select="@contentTitle"/>",
+                           "<xsl:value-of select="@siteName"/>",
+                           "<xsl:value-of select="@lastContributor"/>",
+                           "<xsl:value-of select="@stillExists"/>"
                        );
                    </xsl:for-each>
                    
Index: main/plugin-forms/resources/js/org/ametys/forms/Components.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/Components.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/Components.i18n.js	(working copy)
@@ -1557,7 +1557,6 @@
 
 	org.ametys.forms._currentRegexpTypeNode = input;
 
-	var off = target == null || node == null;
 	if (!input || input.getAttribute("input_text") == null)
 	{
 		combo.getElements().each(function(element) {element.setDisabled(true);});
Index: main/plugin-forms/resources/js/org/ametys/forms/Conversions.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/Conversions.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/Conversions.i18n.js	(working copy)
@@ -40,7 +40,8 @@
 	tag.handleAttribute("form_receipt_body");
 	tag.handleAttribute("form_redirect");
 	
-	tag.handleAttribute("layout")
+	tag.handleAttribute("layout");
+	tag.handleAttribute("form_workflow");
 
 	var lbltag = org.ametys.cms.editor.Editor.handleTag("label");
 	lbltag.handleAttribute("for");
@@ -209,6 +210,7 @@
 			regexpGetContentFormFull, 
 			function (s) 
 			{
+				
 				return s.substring(0, s.length - 6) + "&lt;/form&gt;";
 			}
 	);
@@ -230,6 +232,7 @@
 				var receiptSubject = (type != '' &amp;&amp; (/form_receipt_subject="([^"]*)"/.test(s))) ? (' receipt_subject="' + RegExp.$1 + '"') : '';
 				var receiptBody = (type != '' &amp;&amp; (/form_receipt_body="([^"]*)"/.test(s))) ? (' receipt_body="' + RegExp.$1 + '"') : '';
 				var redirect = (type != '' &amp;&amp; (/form_redirect="([^"]*)"/.test(s))) ? (' redirect="' + RegExp.$1 + '"') : '';
+				var workflow = (type != '' &amp;&amp; (/form_workflow="([^"]*)"/.test(s))) ? (' workflow="' + RegExp.$1 + '"') : '';
 				
                 var cssClass = '';
                 var handledCssClass = org.ametys.forms.getHandledLayoutClass();
@@ -251,7 +254,7 @@
 				/layout="([^"]*)"/.test(s);
 				var layout = RegExp.$1;
 
-				return '&lt;form' + type + target + label + action + id + redirect + receiptTo + receiptFrom + receiptSubject + receiptBody + processingEmails + cssClass + ' layout="' + layout + '"&gt;';
+				return '&lt;form' + type + target + label + action + id + redirect + receiptTo + receiptFrom + receiptSubject + receiptBody + processingEmails + workflow + cssClass + ' layout="' + layout + '"&gt;';
 			}
 	);
 
@@ -376,15 +379,16 @@
 				var receiptSubject = (type != '' &amp;&amp; (/receipt_subject="([^"]*)"/.test(s))) ? (' form_receipt_subject="' + RegExp.$1 + '"') : '';
 				var receiptBody = (type != '' &amp;&amp; (/receipt_body="([^"]*)"/.test(s))) ? (' form_receipt_body="' + RegExp.$1 + '"') : '';
 				var redirect = (type != '' &amp;&amp; (/redirect="([^"]*)"/.test(s))) ? (' form_redirect="' + RegExp.$1 + '"') : '';
-
+				var formWorkflow = (type != '' &amp;&amp; (/workflow="([^"]*)"/.test(s))) ? (' form_workflow="' + RegExp.$1 + '"') : '';
+				
 				/layout="([^"]*)"/.test(s);
 				var layout = RegExp.$1;
-                
+
                 /class="([^"]*)"/.test(s);
                 var cssClass = RegExp.$1;
 
 				regexpSetContentForm.test(s);
-				return '&lt;div form="form" class="form' + (type != '' ? ' cmsForm' : '') + (cssClass != '' ? ' ' + cssClass : '') + '"' + type + id + target + processingEmails + redirect + receiptTo + receiptFrom + receiptSubject + receiptBody + action + label + ' layout="' + layout + '"&gt;';
+				return '&lt;div form="form" class="form' + (type != '' ? ' cmsForm' : '') + (cssClass != '' ? ' ' + cssClass : '') + '"' + type + id + target + processingEmails + redirect + receiptTo + receiptFrom + receiptSubject + receiptBody + action + label + formWorkflow + ' layout="' + layout + '"&gt;';
 			}
 	);
 
@@ -434,7 +438,7 @@
 				var multiple = / multiple="true"/.test(s) ? ' multiple="multiple"' : '';
 				var mandatory = / mandatory="true"/.test(s) ? ' mandatory="mandatory"' : '';
                 var placeholder = / placeholder="([^"]*)"/.test(s) ? ' form_placeholder="' + RegExp.$1 + '"' : '';
-                
+
 				var width = / width="([^"]*)"/.test(s) ? ' width="' + RegExp.$1 + '"' : '';
 				var height = / height="([^"]*)"/.test(s) ? ' height="' + RegExp.$1 + '"' : '';
 				
@@ -466,7 +470,7 @@
 				var width = / width="([^"]*)"/.test(s) ? ' width="' + RegExp.$1 + '"' : '';
 				var height = / height="([^"]*)"/.test(s) ? ' height="' + RegExp.$1 + '"' : '';
 				var placeholder = / placeholder="([^"]*)"/.test(s) ? ' form_placeholder="' + RegExp.$1 + '"' : '';
-                
+				
 				return org.ametys.forms._createHTML(name, id, 'class="form_captcha" captcha="captcha"' + width + height + placeholder);
 			}
 	);
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js	(working copy)
@@ -26,9 +26,9 @@
     org.ametys.forms.ChooseForm.act(org.ametys.ribbon.RibbonManager.getInstance().getControls()[controlId], org.ametys.forms.buttons.Action.showSelectedForm);
 }
 
-org.ametys.forms.buttons.Action.showSelectedForm = function(id, encodedLabel, label)
+org.ametys.forms.buttons.Action.showSelectedForm = function(id, encodedLabel, workflowName)
 {
-	org.ametys.uitool.ToolsManager.getInstance().openTool('uitool-form-entries', { id: id, encodedLabel: encodedLabel, label: label});
+	org.ametys.uitool.ToolsManager.getInstance().openTool('uitool-form-entries', { id: id, encodedLabel: encodedLabel, workflowName: workflowName});
 }
 
 org.ametys.forms.ChooseForm = {};
@@ -220,9 +220,9 @@
         
         var formId = selection[0].id;
         var formEncodedLabel = selection[0].get('encodedName');
-        var formLabel = selection[0].get('name');
+        var formWorkflowName = selection[0].get('workflowName');
         
-        org.ametys.forms.ChooseForm._callback(formId, formEncodedLabel, formLabel);
+        org.ametys.forms.ChooseForm._callback(formId, formEncodedLabel, formWorkflowName);
     }
     else
     {
@@ -296,7 +296,7 @@
     	                        org.ametys.servercomm.ServerComm.PRIORITY_MAJOR,
     	                        org.ametys.forms.entry.DeleteEntry._deleteEntriesCb, 
     	                        this, 
-    	                        [entryIds, formIds[0]]
+    	                        [entryIds, formIds[0], formTarget.getParameters().workflowName]
     	                    );
     	                    org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
     	                }
@@ -314,15 +314,23 @@
         return;
     }
     
-    var targets = [];
+    var targetParams = {};
+    targetParams.id = args[1];
     
-    var entryIds = args[0];
-    for (var i=0; i &lt; entryIds.length; i++)
+    if (args[2])
 	{
-    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': entryIds[i], 'form': args[1] }));
+    	targetParams.workflowName = args[2];
 	}
     
-    var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED, null, targets);
+	var target = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', targetParams);
+	
+	var entryIds = args[0];
+	for (var i=0; i &lt; entryIds.length; i++)
+    {
+		target.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': entryIds[i]}));
+    }
+    
+    var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED, null, [target]);
     org.ametys.messagebus.MessageBus.getInstance().fireMessages([message]);
 }
 
@@ -488,3 +496,11 @@
     form.findField("tableName").setValue(request.getAttribute('tableName'));
     form.findField("request").setValue(request[org.ametys.servercomm.ServerComm.xmlTextContent]);
 }
+
+org.ametys.forms.OpenForm = function()
+{
+	var targets = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
+	var contentFormTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, function(target) {return target.getType() == 'content-form';});
+	
+	org.ametys.forms.buttons.Action.showSelectedForm(contentFormTarget.getParameters().id, contentFormTarget.getParameters().encodedLabel, contentFormTarget.getParameters().workflowName);
+}
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js	(working copy)
@@ -29,10 +29,11 @@
     var mapping = Ext.data.Record.create([
         {name: 'id', mapping: '@id'},
         {name: 'encodedLabel', mapping: '@encodedLabel'},
-        {name: 'name', mapping: 'name'},
+        {name: 'workflowName', mapping: '@workflowName'},
+		{name: 'name', mapping: 'name'},
         {name: 'contentName'},
         {name: 'contentId'},
-        {name: 'contentTitle'},
+        {name: 'contentTitle', mapping: 'contentTitle'},
         {name: 'answersAmount', mapping: 'answersAmount'},
         {name: 'lastAnswer', mapping: 'lastAnswer'}
     ]);
@@ -53,7 +54,7 @@
                 id: '@id'
             },
             mapping
-        ),
+        )
     });
     
     this._xmlStore.on('beforeload', this._onBeforeLoad, this);
@@ -130,8 +131,9 @@
 	var id = record.get('id');
 	var label = record.get('name');
 	var encodedLabel = record.get('encodedLabel');
+	var workflowName = record.get('workflowName');
 	
-	org.ametys.uitool.ToolsManager.getInstance().openTool ("uitool-form-entries", { id: id, encodedLabel: encodedLabel, label: label});
+	org.ametys.uitool.ToolsManager.getInstance().openTool ("uitool-form-entries", { id: id, encodedLabel: encodedLabel, label: label, workflowName: workflowName});
 }
 
 /**
@@ -152,11 +154,16 @@
     
     for (var i=0; i &lt; records.length; i++)
     {
-    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
-    		'id': records[i].data.id, 
-    		'encodedLabel': records[i].data.encodedLabel,
-    		'hasEntries': records[i].data.answersAmount > 0
-		}));
+    	var params = {};
+    	params.id = records[i].data.id;
+    	params.encodedLabel = records[i].data.encodedLabel;
+    	params.hasEntries = records[i].data.answersAmount > 0;
+    	if (records[i].data.workflowName)
+		{
+    		params.workflowName = records[i].data.workflowName;
+		}
+    	
+    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', params));
     }
 	
     var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, targets);
@@ -333,6 +340,7 @@
     return '&lt;a class="link-content" href="javascript:org.ametys.uitool.ToolsManager.getInstance().openTool(\'uitool-content\', {\'id\': \'' + record.get('contentId') + '\'})"&gt;' + value + '&lt;/a&gt;';
 }
 
+
 /**
  * Listens when the store is about to load or reload.
  * @private
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsTool.i18n.js	(working copy)
@@ -60,18 +60,25 @@
 
 org.ametys.forms.tool.FormsTool.prototype._sendCurrentSelection = function ()
 {
-	var records = this._resultGrid.getSelectionModel().getSelections();
+	var records = this._resultGrid.getSelectionModel().getSelections(); 
 	var hasEntries = this._resultGrid.getStore().getTotalCount() > 0;
 	
-	var formTarget = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
-			'id': this._formId, 
-			'encodedLabel': this._formEncodedLabel,
-			'hasEntries': hasEntries
-	});
+	var formTargetParams = {};
+	
+	formTargetParams.id = this._formId;
+	formTargetParams.encodedLabel = this._formEncodedLabel;
+	formTargetParams.hasEntries = hasEntries;
+	
+	if (this._workflowName)
+	{
+		formTargetParams.workflowName = this._workflowName;
+	}
+	
+	var formTarget = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', formTargetParams);
 	
     for (var i = 0; i &lt; records.length; i++)
     {
-		formTarget.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': records[i].data.entryId, 'form': this._formId}));
+		formTarget.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': records[i].data.entryId}));
     }
     
     var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, [formTarget]);
@@ -80,10 +87,12 @@
 
 org.ametys.forms.tool.FormsTool.prototype._formId;
 org.ametys.forms.tool.FormsTool.prototype._formEncodedLabel;
+org.ametys.forms.tool.FormsTool.prototype._workflowName;
 org.ametys.forms.tool.FormsTool.prototype.setParams = function (params)
 {
 	this._formId = params.id;
 	this._formEncodedLabel = params.encodedLabel;
+	this._workflowName = params.workflowName;
 	
 	this.refresh();
 }
@@ -108,20 +117,29 @@
 {
     for (var i = messages.length - 1; i >= 0; i--)
     {
-        if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED)
+        if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED 
+           || messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGED)
         {
             var targets = messages[i].getTargets();
-            var allTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function(target) { return target.getType() == "form-entry";});
+            var allContentFormTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function(target) { return target.getType() == "content-form";});
 
-            if (allTargets != null)
+            if (allContentFormTargets != null)
             {
-                for (var j=0; j &lt; allTargets.length; j++)
+                for (var j=0; j &lt; allContentFormTargets.length; j++)
                 {
-                    if (this._formId == allTargets[j].getParameters().form)
-                    {
-                    	this.outOfDate(false);
-                    	return;
-                    }
+                	// We need the content form target to have the form id
+                	var formId = allContentFormTargets[j].getParameters().id;
+                	
+                	// The workflow changing or deleted event type is only applicable on form entries
+            		var allFormEntriesTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(allContentFormTargets, function(target) { return target.getType() == "form-entry";});
+                	if (allFormEntriesTargets != null)
+            		{
+	                    if (this._formId == formId)
+	                    {
+	                    	this.outOfDate(false);
+	                    	return;
+	                    }
+                	}
                 }
             }
         }   
@@ -217,6 +235,8 @@
 		}
 	}
 	
+	fields.push({'name': 'workflowStep', mapping: '@workflowStep'});
+	
 	return fields;
 }
 
@@ -266,6 +286,18 @@
 		
 		columns.push(column);
 	}
+	
+	// Workflow id
+	columns.push({
+		header: "<i18n:text i18n:key="PLUGINS_FORMS_CHOOSE_SHOW_FORM_WORKFLOW"/>",
+		id: "workflowStep",
+		dataIndex: "workflowStep",
+		renderer: org.ametys.forms.tool.FormsTool._renderWorkflow,
+		sortable: true,
+		hideable: true,
+		width: 120
+	});
+	
 	return columns;
 }
 
@@ -429,3 +461,15 @@
 	var entryId = record.data.entryId;
 	return "&lt;a class='download' href='" + getPluginDirectUrl('forms') + "/" + context.parameters.siteName + "/download/" + this._formId + "/" + entryId + "/" + fieldId + "/" + value + "'&gt;" + "&lt;img src='" + iconPath  + "'/&gt;" + value + "&lt;/a&gt;";
 }
+
+org.ametys.forms.tool.FormsTool._renderWorkflow = function (value, p, record, rowIndex, colIndex, store)
+{
+	if (value == null || value == '')
+	{
+		return "<i18n:text i18n:key="PLUGINS_FORMS_CHOOSE_SHOW_FORM_WORKFLOW_NO_WORKFLOW"/>";
+	}
+	else
+	{
+		return value;
+	}
+}
Index: main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js	(revision 40266)
+++ main/plugin-forms/resources/js/org/ametys/forms/OrphanForms.i18n.js	(working copy)
@@ -13,7 +13,6 @@
  *  See the License for the specific language governing permissions and
  *  limitations under the License.
  */
-
 Ext.namespace('org.ametys.forms.administration.OrphanForms');
 
 org.ametys.forms.administration.OrphanForms.initialize = function (pluginName)
@@ -28,7 +27,11 @@
 		id:0,
         fields: [
            {name: 'name'},
-           {name: 'total'}
+           {name: 'total'},
+           {name: 'contentTitle'},
+           {name: 'siteName'},
+           {name: 'lastContributor'},
+           {name: 'stillExists'}
         ]
 	});
 	
@@ -43,8 +46,12 @@
         },
         
         columns: [
-            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_NAME'/>", width: 200, dataIndex: 'name'},
-            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_TOTAL'/>", width: 100, dataIndex: 'total'}
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_NAME'/>", width: 260, dataIndex: 'name'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_TOTAL'/>", width: 80, dataIndex: 'total'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_CONTENT_TITLE'/>", width: 100, dataIndex: 'contentTitle'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_SITE_NAME'/>", width: 80, dataIndex: 'siteName'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_LAST_CONTRIBUTOR'/>", width: 110, dataIndex: 'lastContributor'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_COL_STILL_EXISTS'/>", width: 100, dataIndex: 'stillExists', renderer: org.ametys.forms.administration.OrphanForms._renderBoolean}
         ]
     });
 	
@@ -72,11 +79,15 @@
 	});
 }
 
-org.ametys.forms.administration.OrphanForms.addElement = function (id, name, total)
+org.ametys.forms.administration.OrphanForms.addElement = function (id, name, total, contentTitle, siteName, lastContributor, stillExists)
 {
 	org.ametys.forms.administration.OrphanForms._listView.addElement(id, {
 		'name': name,
-		'total': total
+		'total': total,
+		'contentTitle': contentTitle,
+		'siteName': siteName,
+		'lastContributor': lastContributor,
+		'stillExists': stillExists
 	});	
 }
 
@@ -125,6 +136,18 @@
 	org.ametys.forms.administration.OrphanForms._actions.hide();
 }
 
+org.ametys.forms.administration.OrphanForms._renderBoolean = function (value, p, record)
+{
+	if (value == 'true')
+	{
+		return '&lt;img src="' + getPluginResourcesUrl('forms') + '/img/ok_16.png" title="' + "<i18n:text i18n:key="PLUGINS_FORMS_BOOLEAN_YES"/>" + '"/&gt;'
+	}
+	else
+	{
+		return "";
+	}
+}
+
 
 
 
